ompi/mca/ptl/mx/ptl_mx_sendfrag.h File Reference.TH "ompi/mca/ptl/mx/ptl_mx_sendfrag.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/ptl/mx/ptl_mx_sendfrag.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'include/sys/atomic.h'\fP
.br
\fC#include 'mca/ptl/base/ptl_base_sendreq.h'\fP
.br
\fC#include 'mca/ptl/base/ptl_base_sendfrag.h'\fP
.br
\fC#include 'ptl_mx.h'\fP
.br
\fC#include 'ptl_mx_peer.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PTL_MX_SEND_FRAG_ALLOC\fP(sendfrag, rc)"
.br
.ti -1c
.RI "#define \fBMCA_PTL_MX_SEND_FRAG_RETURN\fP(sendfrag)"
.br
.ti -1c
.RI "#define \fBMCA_PTL_MX_SEND_FRAG_INIT_ACK\fP(ack, ptl, frag)"
.br
.ti -1c
.RI "#define \fBMCA_PTL_MX_SEND_FRAG_PROGRESS\fP(frag)"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_ptl_mx_send_frag_t\fP \fBmca_ptl_mx_send_frag_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_ptl_mx_send_frag_t\fP)"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define MCA_PTL_MX_SEND_FRAG_ALLOC(sendfrag, rc)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    opal_list_item_t* item; \
    OMPI_FREE_LIST_GET(&mca_ptl_mx_component.mx_send_frags, item, rc); \
    sendfrag = (mca_ptl_mx_send_frag_t*)item; \
    }
.fi
.SS "#define MCA_PTL_MX_SEND_FRAG_INIT_ACK(ack, ptl, frag)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    mca_ptl_base_header_t* hdr = &((ack)->frag_send.frag_base.frag_header); \
    mca_pml_base_recv_request_t* request = &((frag)->frag_recv.frag_request->req_recv); \
    hdr->hdr_common.hdr_type = MCA_PTL_HDR_TYPE_ACK; \
    hdr->hdr_common.hdr_flags = 0; \
    hdr->hdr_ack.hdr_src_ptr = (frag)->frag_recv.frag_base.frag_header.hdr_rndv.hdr_src_ptr; \
    hdr->hdr_ack.hdr_dst_match.lval = 0; /* for VALGRIND/PURIFY - REPLACE WITH MACRO */ \
    hdr->hdr_ack.hdr_dst_match.pval = request; \
    hdr->hdr_ack.hdr_dst_addr.lval = 0; /* for VALGRIND/PURIFY - REPLACE WITH MACRO */ \
    hdr->hdr_ack.hdr_dst_addr.pval = request->req_base.req_addr; \
    hdr->hdr_ack.hdr_dst_size = request->req_bytes_packed; \
    (ack)->frag_send.frag_request = NULL; \
    (ack)->frag_send.frag_base.frag_peer = (frag)->frag_recv.frag_base.frag_peer; \
    (ack)->frag_send.frag_base.frag_owner = ptl; \
    (ack)->frag_send.frag_base.frag_addr = NULL; \
    (ack)->frag_send.frag_base.frag_size = 0; \
    (ack)->frag_segments[0].segment_length = sizeof(mca_ptl_base_ack_header_t); \
    (ack)->frag_segment_count = 1; \
    (ack)->frag_free = 0; \
}
.fi
.SS "#define MCA_PTL_MX_SEND_FRAG_RETURN(sendfrag)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    int seg_free = sendfrag->frag_free; \
    mx_segment_t *seg_ptr = sendfrag->frag_segments+1; \
    while(seg_free) { \
        if(seg_free & 1) { \
            free(seg_ptr->segment_ptr); \
        } \
        seg_free >>= 1; \
        seg_ptr++; \
    } \
    OMPI_FREE_LIST_RETURN(&mca_ptl_mx_component.mx_send_frags, (opal_list_item_t*)sendfrag); \
    }
.fi
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
